// Port.cpp: implementation of the CPort class.
// Classe che gestisce la comunicazione con una porta del PC
// 
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "lpt.h"
#include "Port.h"
#include "conio.h"
//#include "risorse.h"
#include <winioctl.h>
#include <lm.h>
//#include "porttalk_IOCTL.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CPort::CPort()
{
	OpenPortTalk();
}

CPort::~CPort()
{
	ClosePortTalk();
}

unsigned char CPort::leggi()
{
	value = inport(address);
	if ((value & bit7)>0) bit[7]=1; else bit[7]=0;
	if ((value & bit6)>0) bit[6]=1; else bit[6]=0;
	if ((value & bit5)>0) bit[5]=1; else bit[5]=0;
	if ((value & bit4)>0) bit[4]=1; else bit[4]=0;
	if ((value & bit3)>0) bit[3]=1; else bit[3]=0;
	if ((value & bit2)>0) bit[2]=1; else bit[2]=0;
	if ((value & bit1)>0) bit[1]=1; else bit[1]=0;
	if ((value & bit0)>0) bit[0]=1; else bit[0]=0;
	return value;

}


unsigned char CPort::setout(unsigned int value, unsigned char bitnum)
{
	unsigned char vread;
	vread=leggi();
	if (value==1) vread=vread | bitnum; else vread=vread & (~bitnum);
	outport(0x378,vread);
	return vread;
}




void CPort::outport(unsigned short PortAddress, unsigned char byte)
{
	if (!bIsWindowsNTorLater)
	{
		_outp(PortAddress,byte);
		return;
	};

    unsigned int error;
    DWORD BytesReturned;        
    unsigned char Buffer[3];
    unsigned short * pBuffer;
    pBuffer = (unsigned short *)&Buffer[0];
    *pBuffer = PortAddress;
    Buffer[2] = byte;

    error = DeviceIoControl(PortTalk_Handle,
                            IOCTL_WRITE_PORT_UCHAR,
                            &Buffer,
                            3,
                            NULL,
                            0,
                            &BytesReturned,
                            NULL);

    if (!error) 
		AfxMessageBox("Errore di comunicazione con il driver",MB_OK,0);
		
}

unsigned char CPort::inport(unsigned short PortAddress)
{
    if (!bIsWindowsNTorLater)
	{
		return _inp(PortAddress);
	};

	unsigned int error;
    DWORD BytesReturned;
    unsigned char Buffer[3];
    unsigned short * pBuffer;
    pBuffer = (unsigned short *)&Buffer;
    *pBuffer = PortAddress;

    error = DeviceIoControl(PortTalk_Handle,
                            IOCTL_READ_PORT_UCHAR,
                            &Buffer,
                            2,
                            &Buffer,
                            1,
                            &BytesReturned,
                            NULL);

    if (!error)
		AfxMessageBox("Errore di comunicazione con il driver",MB_OK,0);
    return(Buffer[0]);

}



int CPort::OpenPortTalk()
{
   GetOpSystem();
	if (!bIsWindowsNTorLater) return 0;
	//* Open PortTalk Driver.
	//If we cannot open it, try installing and starting it */
    PortTalk_Handle = CreateFile("\\\\.\\PortTalk", 
                                 GENERIC_READ, 
                                 0, 
                                 NULL,
                                 OPEN_EXISTING, 
                                 FILE_ATTRIBUTE_NORMAL, 
                                 NULL);

    if(PortTalk_Handle == INVALID_HANDLE_VALUE)
	{
            /* Start or Install PortTalk Driver */
            StartPortTalkDriver();
            /* Then try to open once more, before failing */
            PortTalk_Handle = CreateFile("\\\\.\\PortTalk", 
                                         GENERIC_READ, 
                                         0, 
                                         NULL,
                                         OPEN_EXISTING, 
                                         FILE_ATTRIBUTE_NORMAL, 
                                         NULL);
               
		    if(PortTalk_Handle == INVALID_HANDLE_VALUE)
			{
               		AfxMessageBox("PortTalk: Non  possibile comunicare con il driver, Verificare che il driver sia installato",MB_OK,0);
                    return -1;
            }
    }
	return 0;

}

BOOL CPort::GetOpSystem()
{
	OSVERSIONINFO *osvi;
	osvi = new(OSVERSIONINFO);
	osvi->dwOSVersionInfoSize=sizeof(OSVERSIONINFO) ;
	GetVersionEx (osvi);
	bIsWindowsNTorLater = (osvi->dwPlatformId == VER_PLATFORM_WIN32_NT );
	try {delete osvi;}
	catch(...){;};
	return bIsWindowsNTorLater;

}

unsigned char CPort::StartPortTalkDriver()
{
	SC_HANDLE  SchSCManager;
    SC_HANDLE  schService;
    BOOL       ret;
    DWORD      err;

    /* Open Handle to Service Control Manager */
    SchSCManager = OpenSCManager (NULL,                        /* machine (NULL == local) */
                                  NULL,                        /* database (NULL == default) */
                                  SC_MANAGER_ALL_ACCESS);      /* access required */
                         
    if (SchSCManager == NULL)
      if (GetLastError() == ERROR_ACCESS_DENIED) {
         /* We do not have enough rights to open the SCM, therefore we must */
         /* be a poor user with only user rights. */
		  AfxMessageBox("Non si dispongono dei diritti necessari ad installare il driver");
         return(0);
         }

    do {
         /* Open a Handle to the PortTalk Service Database */
         schService = OpenService(SchSCManager,         /* handle to service control manager database */
                                  "PortTalk",           /* pointer to name of service to start */
                                  SERVICE_ALL_ACCESS);  /* type of access to service */

         if (schService == NULL)
            switch (GetLastError()){
                case ERROR_ACCESS_DENIED:
						AfxMessageBox("Non si dispongono dei diritti necessari ad installare il driver");
                        return(0);
                case ERROR_INVALID_NAME:
						AfxMessageBox("Nome del servizio non valido");
                        return(0);
                case ERROR_SERVICE_DOES_NOT_EXIST:
						AfxMessageBox("Il servizio non esiste e verr installato");
                        int ris=InstallPortTalkDriver();
						if (ris<0) return 0;
                        break;
            }
         } while (schService == NULL);

    /* Start the PortTalk Driver. Errors will occur here if PortTalk.SYS file doesn't exist */
    
    ret = StartService (schService,    /* service identifier */
                        0,             /* number of arguments */
                        NULL);         /* pointer to arguments */
                    
    if (ret)
	  AfxMessageBox("Servizio avviato con successo");
    else {
        err = GetLastError();
        if (err == ERROR_SERVICE_ALREADY_RUNNING)
          AfxMessageBox("PortTalk: Il driver  gi in funzione.\n");
        else {
          AfxMessageBox("PortTalk: Errore sconosciuto nell'avvio del servizio.\n");
          AfxMessageBox("PortTalk: Controllare che il file porttalk.sys sia nella cartella di sistema\n");
          return(0);
        }
    }

    /* Close handle to Service Control Manager */
    CloseServiceHandle (schService);
    return(TRUE);
}

int CPort::InstallPortTalkDriver()
{
    SC_HANDLE  SchSCManager;
    SC_HANDLE  schService;
    DWORD      err;
    CHAR       DriverFileName[80];

    /* Get Current Directory. Assumes PortTalk.SYS driver is in this directory.    */
    /* Doesn't detect if file exists, nor if file is on removable media - if this  */
    /* is the case then when windows next boots, the driver will fail to load and  */
    /* a error entry is made in the event viewer to reflect this */

    /* Get System Directory. This should be something like c:\windows\system32 or  */
    /* c:\winnt\system32 with a Maximum Character lenght of 20. As we have a       */
    /* buffer of 80 bytes and a string of 24 bytes to append, we can go for a max  */
    /* of 55 bytes */

    if (!GetSystemDirectory(DriverFileName, 55))
    {
		AfxMessageBox("PortTalk non  riuscito a determinare la cartella di sistema.\nCopiare manualmente il file nella cartella system32/driver",MB_OK,NULL);
		return -1;
    }

    /* Append our Driver Name */
    lstrcat(DriverFileName,"\\Drivers\\PortTalk.sys");
	CString strDummy;
	strDummy.Format("PortTalk copier il driver in %s \n Continuare?",DriverFileName);
	int ret=AfxMessageBox(strDummy,MB_YESNOCANCEL,NULL);
    if (ret!=IDYES)
	{
		AfxMessageBox("Installazione interrotta",MB_OK,NULL);
		return -1;
	}
	/* Copy Driver to System32/drivers directory. This fails if the file doesn't exist. */

    if (!CopyFile("PortTalk.sys", DriverFileName, FALSE))
        {
		AfxMessageBox("Copia del File fallita\nCopiare manualmente il file nella cartella di sistema",MB_OK,NULL);
		return -1;
        }

    /* Open Handle to Service Control Manager */
    SchSCManager = OpenSCManager (NULL,                   /* machine (NULL == local) */
                                  NULL,                   /* database (NULL == default) */
                                  SC_MANAGER_ALL_ACCESS); /* access required */

    /* Create Service/Driver - This adds the appropriate registry keys in */
    /* HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services - It doesn't  */
    /* care if the driver exists, or if the path is correct.              */

    schService = CreateService (SchSCManager,                      /* SCManager database */
                                "PortTalk",                        /* name of service */
                                "PortTalk",                        /* name to display */
                                SERVICE_ALL_ACCESS,                /* desired access */
                                SERVICE_KERNEL_DRIVER,             /* service type */
                                SERVICE_DEMAND_START,              /* start type */
                                SERVICE_ERROR_NORMAL,              /* error control type */
                                "System32\\Drivers\\PortTalk.sys", /* service's binary */
                                NULL,                              /* no load ordering group */
                                NULL,                              /* no tag identifier */
                                NULL,                              /* no dependencies */
                                NULL,                              /* LocalSystem account */
                                NULL                               /* no password */
                                );

    if (schService == NULL) {
         err = GetLastError();
         if (err == ERROR_SERVICE_EXISTS)
			AfxMessageBox("Servizio gi presente nel sistema",MB_OK,NULL);
         else  	AfxMessageBox("Errore nell'installazione del sistema",MB_OK,NULL);
    
    }
    else AfxMessageBox("Installazione riuscita con successo",MB_OK,NULL);

    /* Close Handle to Service Control Manager */
    CloseServiceHandle (schService);
	return 0;
}

void CPort::ClosePortTalk()
{
    if (bIsWindowsNTorLater) CloseHandle(PortTalk_Handle);
}
